define(['jquery'], function ($) {
	var CustomWidget = function () {
		var self = this;

		this.getBaseUrl = function(){
			var serverUrl = 'https://youplatform.ru/admin/';
			return serverUrl;
		};

		this.notifications = function(header, message) {
			AMOCRM.notifications.show_message_error({
				text: message || '', header: header || ''
			});
		};

		this.callbacks = {
			render: function () {
				var settings = self.get_settings();

				self.initPromise = new Promise(function (resolve, reject) {
					try {
						var active = false;
						try {
							active = AMOCRM.constant("widgets").widgets.all[self.params.widget_code].active;
						} catch (e) {

						}

						if (
							(self.params.installed === 'Y' || self.params.widget_active === 'Y' || active)
							&& !window.youplatformWidget
						) {
							require([
								self.getBaseUrl()+ 'panel-loader/loader?' +
								'SUBDOMAIN=' + AMOCRM.widgets.system.subdomain +
								'&DOMAIN=' + AMOCRM.widgets.system.domain +
								'&API_KEY=' + settings.api_key +
								'&v=' + (new Date()).getDay()
							], function() {

							});
						}
					} catch (ex) {
						self.notifications('Ошибка подключения YouPlatform', 'Проверьте данные и включен ли виджет');
					}
				});
				return true;
			},
			init: function () {
				if(!$('*').is('#youplatform_panel_style')) {
					$("head").append('<link id = "youplatform_panel_style" type="text/css" rel="stylesheet" href="' + self.params.path + '/css/style.css?' + (new Date()).getDay() + '">');
				}
				return true;
			},
			bind_actions: function () {
				return true;
			},
			settings: function (modal_body) {
				var lang = self.i18n('userLang');
				var settings = self.get_settings();

				$('#widget_settings__fields_wrapper').after('\
					<div class="yp-widget-email-footer">\
					' + lang.support + '<br>\
					e-mail: support@youplatform.ru<br>\
					phone: +7(915)802-86-48<br>\
					'+ lang.our_chanal +' <a href="https://www.youtube.com/channel/UCMeTHU_vYv9MBp-9UQO68aA" target = "_blanck">YouTube</a><br>\
					<a href="https://youplatform.ru/?utm_source=amoCRM&utm_medium=widget&utm_campaign=youplatform_panel" target = "_blanck">youplatform.ru</a>\
				</div>');

				self.crm_post(
					self.getBaseUrl()+"app/check-user-and-include",
					{
						action: "check",
						api_key: settings.api_key,
						w_code: 'panel'
					},
					function(response) {
						var text = '';
						var class_text = '';

						if(response.status == 'ok'){
							class_text = 'yp-success';
							text = lang.widget_include;
						}
						if(response.status == 'not_found_user'){
							class_text = 'yp-warning';
							text = lang.not_found_user;
						}
						if(response.status == 'not_include_widget'){
							class_text = 'yp-warning';
							text = lang.not_include_widget;
						}
						if(response.status == 'not_api_key'){
							class_text = 'yp-warning';
							text = lang.not_api_key;
						}
						$('#widget_settings__fields_wrapper').after('\
						<div class="yp-widget-status">\
								<p class = "'+ class_text +'">'+ text +'</p>\
						</div>');
					},
					'json'
				);
				return true;
			},
			onSave: function () {
				return true;
			},
			destroy: function () {
				return true;
			},
			contacts: {
				selected: function () {
					return true;
				}
			},
			leads: {
				selected: function () {
					return true;
				}
			},
			tasks: {
				selected: function () {
					return true;
				}
			},
		};
		return this;
	};

	return CustomWidget;
});